<div layout:decorate="~{layouts/default}" xmlns:th="http://www.thymeleaf.org"
     xmlns:layout="http://www.w3.org/1999/xhtml">
    <div layout:fragment="content">
        <div class="card">
            <div class="card-header">
                <h1 th:text="#{book_manage.header}"></h1>
            </div>
            <div class="card-body">
                <div id="dxForm"></div>
            </div>
            <div class="card-footer text-end">
                <div id="dxBtn"></div>
            </div>
        </div>



        <script th:inline="javascript" type="text/javascript">
            FormEditor = {};

            /*<![CDATA[*/
            FormEditor.urlSaveData = [[@{/books-management/addBook}]]
            FormEditor.urlSuccessRedirect = [[@{/}]]

            FormEditor.formData = [[${formModel}]]



            FormEditor.dxFormInstance = null;
            FormEditor.validationErrors = null;

            FormEditor.init = function(){
                FormEditor.validationErrors = null;

                $("#dxForm").dxForm({
                    formData: FormEditor.formData,
                    onInitialized: function(e){ FormEditor.dxFormInstance = e.component },
                    items: [
                        {dataField: "authorName",
                            label: {text: [[#{common.field.authorName}]]},
                            validationRules: [
                                {
                                    type: "custom",
                                    reevaluate: true,
                                    validationCallback: FormEditor.validationCallback
                                }

                            ]},
                        {dataField: "bookName",
                            label: {text: [[#{common.field.bookName}]]},
                            validationRules: [
                                {
                                    type: "custom",
                                    reevaluate: true,
                                    validationCallback: FormEditor.validationCallback
                                }

                            ]
                        },
                        {dataField: "bookISBN",
                            label: {text: [[#{common.field.isbn}]]},
                            validationRules: [
                                {
                                    type: "custom",
                                    reevaluate: true,
                                    validationCallback: FormEditor.validationCallback
                                }

                            ]
                        }

                    ]
                })

               $("#dxBtn").dxButton({
                    text: [[#{book_manage.btn_add.label}]],
                    onClick: function(){
                        const formData = FormEditor.dxFormInstance.option("formData");

                        FormEditor.validationErrors = null;

                        $.ajax({
                                url: FormEditor.urlSaveData,
                                data: JSON.stringify(formData),
                                type: 'post',
                                contentType: "application/json; charset=utf-8",
                                success: function(response){
                                    FormEditor.onFormSuccess(response);
                                },
                                error: function(response){
                                    if(FormEditor.isFormValidationResponse(response)){
                                        FormEditor.onFormError(response.responseJSON)
                                    }else{
                                        DevExpress.ui.dialog.alert("Server error occoured", "Error");
                                    }
                                }
                            }
                        )
                    }
                })
            }

            FormEditor.onFormError = function(responseData){
                FormEditor.validationErrors = responseData.formValidationErrors;

                FormEditor.dxFormInstance.validate();

                FormEditor.validationErrors = null;
            }

            FormEditor.isFormValidationResponse = function(response){
                if(response.status !== 400){
                    return false;
                }

                const hasJSONResponse = response.responseJSON !== null && response.responseJSON !== undefined;

                if(!hasJSONResponse){
                    return false;
                }

                const formValidationErrors = response.responseJSON.formValidationErrors;

                return formValidationErrors !== undefined && formValidationErrors !== null;
            }

            FormEditor.onFormSuccess = function(responseData){
                window.location.href = FormEditor.urlSuccessRedirect;
            }

            FormEditor.validationCallback = function(params){
                if(FormEditor.validationErrors === null){
                    return true;
                }

                const fieldValidationError = FormEditor.validationErrors[params.formItem.dataField];

                const isValid = (fieldValidationError === undefined || fieldValidationError === null);

                if(isValid){
                    params.rule.message = null;
                }else{
                    params.rule.message = fieldValidationError;
                }

                return isValid;
            }

            jQuery(function($){
                FormEditor.init();
            })

            /*]]>*/
        </script>
    </div>
</div>